package cz.upol.foolang.jbc;

import javassist.CtClass;
import javassist.NotFoundException;

public class Util {
	
	public static String typeSignature(CtClass clazz) {
		if (clazz == CtClass.intType) return "I";
		if (clazz == CtClass.byteType) return "B";
		if (clazz == CtClass.charType) return "C";
		if (clazz == CtClass.doubleType) return "D";
		if (clazz == CtClass.floatType) return "F";
		if (clazz == CtClass.longType) return "J";
		if (clazz == CtClass.shortType) return "S";
		if (clazz == CtClass.booleanType) return "Z";
		if (clazz == CtClass.voidType) return "V";
		
		if (clazz.isArray()) {
			try {
				return "[" + typeSignature(clazz.getComponentType());
			} catch (NotFoundException e) {
				return "[error";
			}
		}
		
		return "L" + clazz.getName().replace('.', '/') + ";";
	}
}
